Subject: RE: [SIP] New Section 6.34 (was: Record-Route consensus)

From: "Fairlie-Cuninghame, Robert" <[email-masked]>
Date: Thu, 23 Nov 2000 20:10:40 -0800

I think we also need to clarify the use of angle brackets in the
Record-Route header. They may interfere with the inclusion on the route
parameters in the Request-URI (which cannot use angle brackets). Eg,

Record-Route: <sip:sip%3aA%64originating.com@proxy>;rstate=253878954375364

is "correct" but will probably cause problems in some proxies/UA's as only
the base url (<...>) will be copied into the Request-URI.

I think the best suggestion for proxies is to either a) not to use angle
brackets in Record-Route hoeaders or b) include all record-route parameters
inside the angle brackets. 

The latter is more general (KISS) but is a slight bending of the definition
of "record-route parameters". However, the parameters _are_ being treated as
URL parameters in the Request-URI so the behaviour makes sense from that
respect.

Agree?
 
Regards,

Robert.

-- My opinions are my own. I tried selling them once but everybody
	seems to already have one. -- 
> -----Original Message-----
> From: Jo Hornsby [mailto:[email-masked]]
> Sent: Thursday, November 23, 2000 10:52 PM
> To: Fairlie-Cuninghame, Robert; Jonathan Rosenberg
> Cc: [email-masked]
> Subject: RE: [SIP] New Section 6.34 (was: Record-Route consensus)
> 
> 
> Robert Fairlie-Cuninghame wrote:
> > > Very nice -- it's cool that you've found a way to maintain
> > > "the Request-URI points to the ultimate destination" as an
> > > invariant.
> >
> > I still don't see how this is the case. You just have two different
> > URL's located at the proxy server. I don't see they point to the
> > ultimate destination (unless I missing something fundamental).
> 
> They might not point to the ultimate destination, per se; but
> the Request-URI will be meaningful enough to the proxy such
> that it could reapply its initial routing decisions, if
> necessary.
> 
> > >   Each Record-Route header field contains a globally 
> reachable SIP URL
> > >  that identifies a proxy server.  Any proxy that wishes 
> to remain in
> > >  the signalling path of a call leg adds its own SIP URL to the
> > >  beginning of the list of these fields in a request.  This SIP URL
> > >  MUST represent an address that is reachable via UDP, and SHOULD
> > >  represent the calling UA (i.e., be derived from the 
> Contact/From).
> >
> > As above, I don't understand how it "represents" the UA in any
> > sense outside the proxy's internal implementation. I am not saying
> > that this is a bad idea but I do think this wording will cause a
> > lot of confusion.
> 
> I see what you're saying -- my wording is confusing upon reading
> it back.  Hmmm...
> 
> > Do you derive it from the just the user part of the Contact/From ?
> > What if the user name is the same (jack@A <-> jack@B?)? Are you
> > suggestign we put an escaped copy of the whole Contact/From into
> > the username portion of the Route ?
> 
> This is probably what I would do, in fact.
> 
> > Why not just say
> >
> > "This SIP URL MUST represent an address that is reachable 
> via UDP, and the
> > user portion SHOULD be distinguishable by the proxy as 
> being destined for
> > the calling UA. The URL SHOULD also be distguishable from 
> any previous
> > Record-Route entries added by the proxy (e.g., due to 
> spiraling routes)."
> 
> Basically because I'd rather we imply as little as possible about
> the format of this URL; however, I think we're getting warmer.
> 
> How about:
>     This SIP URL MUST represent an address that is reachable via
>     UDP, and SHOULD somehow be meaningful to the proxy, such that
>     it could map the URL back to the calling UA (e.g., by embedding
>     the Contact/From ha a parameter).
> ?
> 
> > > > >  *** If no Contact, should add the From?
> >
> > Is there a reason why we should change the existing behaviour ?
> 
> I wasn't sure what the existing behaviour was...
> 
> 
>  - Jo.
> 
> 
> _______________________________________________
> SIP mailing list
> [email-masked]
> http://lists.bell-labs.com/mailman/listinfo/sip
> 

_______________________________________________
SIP mailing list
[email-masked]
http://lists.bell-labs.com/mailman/listinfo/sip

---

From: "Jo Hornsby" <[email-masked]>
Date: Fri, 24 Nov 2000 11:08:52 -0000

Robert Fairlie-Cuninghame wrote:
> brackets in Record-Route hoeaders or b) include all record-route
> parameters inside the angle brackets.
>
> The latter is more general (KISS) but is a slight bending of the
> definition of "record-route parameters".

Indeed. &:)

> However, the parameters
> _are_ being treated as URL parameters in the Request-URI so the
> behaviour makes sense from that respect.

I'm not quite with you here, but I think I agree.  As things
currently stand, it doesn't look like Record-Route parameters
are particularly useful; however, this doesn't mean we won't
think of some funky new use in the future.

Therefore, at the moment, it might be wise to note that
proxies probably always want to use angle brackets.  Just to
be sure.

Cheers,

 - Jo.